/*
 * Copyright (c) 1992-1994 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Id: os-sunos5.h,v 1.28 1996/02/14 22:26:27 mcooper Exp $
 */

#ifndef __os_sunos5_h__
#define __os_sunos5_h__

/*
 * SunOS 5.x
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/fcntl.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/cpu.h>
#include <sys/systeminfo.h>
#include <sys/idprom.h>
#include <sys/fbio.h>
#include <sys/mtio.h>
#include <sys/dkio.h>
#include <sys/hdio.h>
#include <sys/vtoc.h>
#include <sys/mnttab.h>
#include <sys/vfstab.h>
#include "os-sunos.h"

#if	!defined(SUNOS)
#define SUNOS 		5
#endif	/* SUNOS */

#if	!defined(ELF)
#define ELF 		1
#endif	/* ELF */

/*
 * What manufacturer is this?
 */
#if defined(TAD_SPBK_ARCH)
#	define TADPOLE
#else
#if defined(CPU_TYPE_SERIES4) || defined(CPU_TYPE_SERIES5) || \
    	   defined(CPU_TYPE_SERIES5E) || defined(CPU_TYPE_SERIES6)
#	define SOLBOURNE
#else
#	define HAVE_SUNROMVEC
#endif
#endif

#define IS_POSIX_SOURCE
#define HAVE_ANONINFO
#define HAVE_DEVICE_SUPPORT
#define HAVE_DLPI
#define HAVE_GETHOSTID
#define HAVE_IDPROM
#define HAVE_KVM
#define HAVE_NLIST
#define HAVE_OPENPROM
#define HAVE_SYSINFO
#define NEED_SOCKIO
/*
 * regcomp(3c) first appeared in SunOS 5.4
 */
#if	defined(OSVER) && OSVER < 54
#define RE_TYPE			RE_REGCMP
#else
#define RE_TYPE			RE_REGCOMP
#endif	/* OSVER */

/*
 * Paths
 */
#define _PATH_DEV		"/dev"
#define _PATH_DEV_DSK		"/dev/dsk"
#define _PATH_DEV_FBS		"/dev/fbs"
#define _PATH_DEV_RDSK		"/dev/rdsk"
#define _PATH_DEV_RMT		"/dev/rmt"

#if defined(HAVE_OPENPROM)
#	include <sys/openpromio.h>
#endif

/*
 * Types
 */
typedef struct vtoc		DKvtoc;
typedef struct dk_cinfo		DKcinfo;
typedef struct dk_geom		DKgeom;
typedef struct hdk_type		DKtype;

#endif	/* __os_sunos5_h__ */
